/* tslint:disable */
/* eslint-disable */
/**
 * OpenAPI definition
 * No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)
 *
 * The version of the OpenAPI document: v0
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EntityModelLocation } from '../model';
/**
 * LocationSearchControllerApi - axios parameter creator
 * @export
 */
export const LocationSearchControllerApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {string} [name] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        executeSearchLocationGet: async (name?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/locations/search/findByName`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            if (name !== undefined) {
                localVarQueryParameter['name'] = name;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * LocationSearchControllerApi - functional programming interface
 * @export
 */
export const LocationSearchControllerApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = LocationSearchControllerApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {string} [name] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async executeSearchLocationGet(name?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EntityModelLocation>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.executeSearchLocationGet(name, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * LocationSearchControllerApi - factory interface
 * @export
 */
export const LocationSearchControllerApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = LocationSearchControllerApiFp(configuration)
    return {
        /**
         * 
         * @param {string} [name] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        executeSearchLocationGet(name?: string, options?: any): AxiosPromise<EntityModelLocation> {
            return localVarFp.executeSearchLocationGet(name, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * LocationSearchControllerApi - interface
 * @export
 * @interface LocationSearchControllerApi
 */
export interface LocationSearchControllerApiInterface {
    /**
     * 
     * @param {string} [name] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationSearchControllerApiInterface
     */
    executeSearchLocationGet(name?: string, options?: AxiosRequestConfig): AxiosPromise<EntityModelLocation>;

}

/**
 * LocationSearchControllerApi - object-oriented interface
 * @export
 * @class LocationSearchControllerApi
 * @extends {BaseAPI}
 */
export class LocationSearchControllerApi extends BaseAPI implements LocationSearchControllerApiInterface {
    /**
     * 
     * @param {string} [name] 
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof LocationSearchControllerApi
     */
    public executeSearchLocationGet(name?: string, options?: AxiosRequestConfig) {
        return LocationSearchControllerApiFp(this.configuration).executeSearchLocationGet(name, options).then((request) => request(this.axios, this.basePath));
    }
}
